Index: trunk/MagicSoft/GRB-Proposal/Monitor.tex
===================================================================
--- trunk/MagicSoft/GRB-Proposal/Monitor.tex	(revision 6571)
+++ trunk/MagicSoft/GRB-Proposal/Monitor.tex	(revision 6614)
@@ -6,5 +6,5 @@
 
 The Burst Alarm System {\it gspot} (Gamma
-Sources Pointing Trigger) is working in La Palma since last summer. 
+Sources Pointing Trigger) is installed and working in La Palma since last summer.
 It performs a full-time survey of the {\it GRB Coordinates Network} (\g) alerts~\cite{GCN}.
 Different satellite experiments 
@@ -32,5 +32,5 @@
 
 The format of the data distributed through the \g differ between the individual satellites
-and the kind of package. Currently, three satellites participate in the GRB survey:
+and the kind of package. Currently three satellites participate in the GRB survey:
 HETE-2~\cite{HETE}, INTEGRAL~\cite{INTEGRAL} and SWIFT~\cite{SWIFT}. 
 The alerts include the UTC, the GRB coordinates (not always), error on coordinates
@@ -53,16 +53,13 @@
 shining, the maximal zenith angle is reduced to 65$^\circ$.
 \item {\bf Position of Moon}: The angular
-distance from the GRB to the moon has to be at least 30$^\circ$.
+distance from the GRB to the Moon has to be at least 30$^\circ$.
 \end{itemize}
 
 If one or more of these conditions fail, {\it gspot} enters into a
-{\color[rgb]{0.9,0.75,0.}\bf Yellow Alarm State}: The GRB is not observable at the moment.
-Currently, the program does not calculate if and when the GRB will become observable for \ma.
-If all the  mentioned conditions are satisfied, 
-{\it gspot} enters into a \textcolor{red}{\bf Red Alarm State}, meaning that the GRB is observable.\\
+{\color[rgb]{0.9,0.75,0.}\bf Yellow Alarm State} (the GRB is not observable at the moment). In this case the program saves the alert in a list and calculates when the GRB will become observable for \ma. In the moment when the criteria above will be fulfilled for this burst, and the time intervall after the burst onset is smaller than 5 hours, {\it gspot} enters into \textcolor{red}{\bf Red Alarm State}.
+If all the mentioned conditions are satisfied from the beginning, {\it gspot} enters into a \textcolor{red}{\bf Red Alarm State} immediately.\\
 
 In both cases (\textcolor{red}{\bf RED} or {\color[rgb]{0.9,0.75,0.}\bf YELLOW} Alarm State), {\it gspot} establishes the communication with the CC and sends the GRB equatorial coordinates (RA/DEC J2000).
-For the communication with CC the format defined in~\cite{CONTROL} is used. At the same time,
-the shifters and the GRB-MAGIC group is contacted.
+For the communication with CC the format defined in~\cite{CONTROL} is used. At the same time, the shifters and the GRB-MAGIC group are contacted.
 
 \subsection{The Interface to the Central Control}
@@ -77,6 +74,6 @@
 \begin{itemize}
 \item {\it gspot} receives from the CC the confirmation
-that the alert notice has been received; The CC must send back the alert in order
-to perform a cross-check of the relevant data.
+that the alert notice has been received. (The CC must send back the alert in order
+to perform a cross-check of the relevant data.)
 \item the alarm state expires after {\bf 5 hours}
 \end{itemize}
@@ -100,7 +97,6 @@
 \subsection{The GRB Web Page}
 
-The status of the GRB Alert System and relevant informations about the latest
-alerts are displayed on a separate web page. The page is hosted at the web server in La Palma a
-and can be accessed under:\\
+The status of the GRB Alert System and relevant informations about the last
+alert are displayed on a separate web page. The page is hosted at the web server in La Palma and can be accessed under:\\
 
 \qquad \qquad http://www.magic.iac.es/site/grbm/\\
@@ -116,5 +112,5 @@
 even if the CC is switched off, so that persons in the counting house
 can be noticed about the alert situation. The signal will be on as long as
-{\it gspot} remains in alarm state for a minimum of 1 minute.
+{\it gspot} remains in alarm state for a minimum of one minute.
 The device features also a display with the status of the system and the alert.
 
@@ -125,5 +121,5 @@
 21 contained GRB's coordinates. Time delays to the onset of the burst 
 were of the order of several minutes to tens of minutes. The Burst Monitor can be considered stable 
-since November, 2004. Since then, we have received the following two significant alerts:\\
+since November 2004. Since then we have received the following two significant alerts:\\
 
 \begin{tabular}{lllcccl}
@@ -136,6 +132,5 @@
 \subsection{Experience from SWIFT GRBs until now}
 
-According to the \sw home page~\cite{SWIFT}, the satellite has detected 16 GRBs since mid-December last year. The bursts were detected by chance during the commissioning phase. Since 15th of February the satellite sends burst allerts to the \g in real time. The current sample contains three bursts which could have been observed by \ma. The coordinates of the last burst from 15th February were send via an
-alert within few seconds. Also in this cases the weather conditions did not allow any observation.\\
+According to the \sw home page~\cite{SWIFT}, the satellite has detected 16 GRBs since mid-December last year. The bursts were detected by chance during the commissioning phase. Since February 15$^{\mathrm{th}}$ the satellite sends burst allerts to the \g in real time. The current sample contains three bursts which could have been observed by \ma. The coordinates of the last burst from February 15$^{\mathrm{th}}$ were send via an alert within few seconds. Also in this cases the weather conditions did not allow any observation.\\
 
 \begin{tabular}{lllcc}