Index: trunk/MagicSoft/Mars/mjobs/MJCalib.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalib.cc	(revision 6776)
+++ trunk/MagicSoft/Mars/mjobs/MJCalib.cc	(revision 6777)
@@ -50,5 +50,6 @@
 //
 MJCalib::MJCalib() : fDataFlag(kIsUseRootData), fStorage(0), 
-                     fPixelCheck(kFALSE), fPulsePosCheck(kFALSE),
+                     fIsPixelCheck(kFALSE), fIsPulsePosCheck(kFALSE),
+                     fIsHiLoCalibration(kFALSE),
                      fRuns(NULL)
 {
@@ -59,11 +60,14 @@
 {
     if (HasEnv("PixelCheck"))
-        SetPixelCheck(GetEnv("PixelCheck", fPixelCheck));
+        SetPixelCheck(GetEnv("PixelCheck", fIsPixelCheck));
 
     if (HasEnv("PulsePosCheck"))
-        SetPulsePosCheck(GetEnv("PulsePosCheck", fPulsePosCheck));
+        SetPulsePosCheck(GetEnv("PulsePosCheck", fIsPulsePosCheck));
 
     if (HasEnv("CheckedPixId"))
         SetCheckedPixId(GetEnv("CheckedPixId",fCheckedPixId));
+
+    if (HasEnv("HiLoCalibration"))    
+      SetHiLoCalibration(GetEnv("HiLoCalibration", fIsHiLoCalibration));
 
     if (HasEnv("StorageType"))
Index: trunk/MagicSoft/Mars/mjobs/MJCalib.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalib.h	(revision 6776)
+++ trunk/MagicSoft/Mars/mjobs/MJCalib.h	(revision 6777)
@@ -34,8 +34,9 @@
 protected:
 
-    Bool_t fPixelCheck;                 // Check a test pixel?
+    Bool_t fIsPixelCheck;               // Check a test pixel?
     Int_t  fCheckedPixId;               // ID of checked pixel
 
-    Bool_t fPulsePosCheck;              // Check pulse position?
+    Bool_t fIsPulsePosCheck;            // Check pulse position?
+    Bool_t fIsHiLoCalibration;          // Choose to calibrate the high-gain vs. low-gains
     
     MRunIter *fRuns;                    // Data files, only used for test applications, default is sequence files!
@@ -63,10 +64,12 @@
     void SetDataType(DataType_t type) { fDataFlag=type; }
   
-    void SetPixelCheck   ( const Bool_t b=kTRUE )          { fPixelCheck    = b; }
-    void SetPulsePosCheck( const Bool_t b=kTRUE )          { fPulsePosCheck = b; }
     void SetCheckedPixId ( const Int_t  i=fgCheckedPixId ) { fCheckedPixId  = i; }
 
     void SetNoStorage    ( const Bool_t b=kTRUE ) { b ? SETBIT(fStorage,kNoStorage)    : CLRBIT(fStorage,kNoStorage); }
     void SetHistsStorage ( const Bool_t b=kTRUE ) { b ? SETBIT(fStorage,kHistsStorage) : CLRBIT(fStorage,kHistsStorage); }
+
+    void SetHiLoCalibration( const Bool_t b=kTRUE )  { fIsHiLoCalibration = b; }
+    void SetPixelCheck     ( const Bool_t b=kTRUE )  { fIsPixelCheck        = b; }
+    void SetPulsePosCheck  ( const Bool_t b=kTRUE )  { fIsPulsePosCheck     = b; }
   
     ClassDef(MJCalib, 0) // Base class for calibration jobs
Index: trunk/MagicSoft/Mars/mjobs/MJCalibTest.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibTest.cc	(revision 6776)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibTest.cc	(revision 6777)
@@ -530,5 +530,5 @@
   tlist.PrintStatistics();
   
-  if (fPixelCheck)
+  if (fIsPixelCheck)
     {
       MHCalibrationTestCam *hcam = (MHCalibrationTestCam*)plist.FindObject("MHCalibrationTestCam");
Index: trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 6776)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 6777)
@@ -127,10 +127,10 @@
 MJCalibrateSignal::MJCalibrateSignal(const char *name, const char *title)
     : fIsInterlaced(kTRUE), fIsRelTimesUpdate(kFALSE), 
-      fIsHiLoCalibration(kFALSE), fIsModifiedExtractWin(kTRUE)
+      fIsModifiedExtractWin(kTRUE)
 {
     fName  = name  ? name  : "MJCalibrateSignal";
     fTitle = title ? title : "Tool to calibrate data";
 
-    fPulsePosCheck = kTRUE;
+    SetPulsePosCheck();
     //fCruns = NULL;
 }
@@ -255,5 +255,4 @@
     SetInterlaced(GetEnv("Interlaced", fIsInterlaced));
     SetRelTimesUpdate(GetEnv("RelTimesUpdate", fIsRelTimesUpdate));
-    SetHiLoCalibration(GetEnv("HiLoCalibration", fIsHiLoCalibration));
     SetModifiedExtractWin(GetEnv("ModifiedExtractWin", fIsModifiedExtractWin));
 
@@ -745,5 +744,5 @@
     if (fIsHiLoCalibration)
       tlist2.AddToList(&filhil);
-    if (fPulsePosCheck)
+    if (fIsPulsePosCheck)
       tlist2.AddToList(&filpul);
     tlist2.AddToList(&fill2);
@@ -815,7 +814,7 @@
     DisplayResult(plist);
 
-    if (fPixelCheck)
+    if (fIsPixelCheck)
       {
-        if (fPulsePosCheck)
+        if (fIsPulsePosCheck)
           {
             MHCalibrationPulseTimeCam *pcam = (MHCalibrationPulseTimeCam*)plist.FindObject("MHCalibrationPulseTimeCam");
@@ -885,5 +884,5 @@
     disp21.SetYTitle("T [FADC sl.]");
 
-    if (fPulsePosCheck)
+    if (fIsPulsePosCheck)
       {
         TCanvas &c0 = fDisplay->AddTab("PulseTime");
Index: trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.h	(revision 6776)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.h	(revision 6777)
@@ -25,5 +25,4 @@
     Bool_t fIsInterlaced;               // Distinguish interlaced from other calibration
     Bool_t fIsRelTimesUpdate;           // Choose to update relative times from interlaced
-    Bool_t fIsHiLoCalibration;          // Choose to calibrate the high-gain vs. low-gains
     Bool_t fIsModifiedExtractWin;       // Choose to use the modified extraction window from pulse position
     
@@ -48,5 +47,4 @@
     void SetInterlaced     ( const Bool_t b=kTRUE )  { fIsInterlaced      = b; }
     void SetRelTimesUpdate ( const Bool_t b=kTRUE )  { fIsRelTimesUpdate  = b; }
-    void SetHiLoCalibration( const Bool_t b=kTRUE )  { fIsHiLoCalibration = b; }
     void SetModifiedExtractWin( const Bool_t b=kTRUE )  { fIsModifiedExtractWin = b; }
 
Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 6776)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 6777)
@@ -200,4 +200,5 @@
   SetUsePINDiode();
   
+  SetHiLoCalibration();
   SetRelTimeCalibration();
   SetDebug(kFALSE);
@@ -1474,4 +1475,7 @@
 {
 
+  if (!fIsHiLoCalibration)
+    return kTRUE;
+
   TFile file(fHiLoCalibFile,"READ");
 
@@ -1971,5 +1975,5 @@
     tlist.PrintStatistics();
 
-  if (fPixelCheck)
+  if (fIsPixelCheck)
     {
       MHCalibrationChargeCam *hcam = (MHCalibrationChargeCam*)plist.FindObject("MHCalibrationChargeCam");
Index: trunk/MagicSoft/Mars/mjobs/MJPedestal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 6776)
+++ trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 6777)
@@ -282,5 +282,5 @@
     //
     MGeomCam           &geomcam   = *(MGeomCam*)plist.FindObject("MGeomCam");
-    MCalibrationPedCam &calpedcam = *(MCalibrationPedCam*)plist.FindObject("MCalibrationPedCam");
+    //    MCalibrationPedCam &calpedcam = *(MCalibrationPedCam*)plist.FindObject("MCalibrationPedCam");
 
     //
@@ -1036,5 +1036,5 @@
     fcalib.SetInverted();
 
-    if (fPulsePosCheck)
+    if (fIsPulsePosCheck)
       {
         fillpul.SetFilter(&fcalib);
@@ -1212,5 +1212,5 @@
     fExtractor->SetFilter(0);
 
-    if (fPixelCheck)
+    if (fIsPixelCheck)
       {
         MHPedestalCam *hcam = (MHPedestalCam*)plist.FindObject("MHPedestalCam");
@@ -1228,9 +1228,9 @@
         return kFALSE;
 
-    if (fPulsePosCheck)
+    if (fIsPulsePosCheck)
       {
 
         MHCalibrationPulseTimeCam *hcam = (MHCalibrationPulseTimeCam*)plist.FindObject("MHCalibrationPulseTimeCam");
-        if (fPixelCheck)
+        if (fIsPixelCheck)
           {
             hcam->DrawClone();