Index: trunk/MagicSoft/GC-Proposal/GC.tex
===================================================================
--- trunk/MagicSoft/GC-Proposal/GC.tex	(revision 6854)
+++ trunk/MagicSoft/GC-Proposal/GC.tex	(revision 6860)
@@ -279,4 +279,7 @@
 where $\langle \sigma v \rangle$ is the thermally averaged annihilation cross section, $m_{\chi}$ the mass and $\rho_{\chi}$ the spatial density distribution of the hypothetical dark matter particles. $N_{\gamma}(E_{\gamma}>E_{\mathrm{th}})$ is the gamma yield above the threshold energy per annihilation. The predicted flux depends on the dark matter particle properties and on the spatial distribution of the dark matter. The energy spectrum of the produced gamma radiation has a very characteristic feature: a sharp cut-off at the mass of the dark matter particle. Also the flux should be absolutely stable in time.
 
+Supersymmetric extensions of the standard model predict the existance of a good dark matter candidate, the neutralino $\chi$. In most models its mass is below a few TeV. Thus also the expected spectral cut-off lies below a few TeV. As the observed spectrum by the HESS experiment extends above 10 TeV it is very unlikely to be only due to neutralino annihilation.
+
+
 Numerical simulations of cold dark matter \cite{NFW1997,Stoehr2002,Hayashi2004,Moore1998} predict universal DM halo profiles with a density enhancement in the center of the dark halo. In the very center the dark matter density can be even more enhanced through an adiabatic compression due to the baryons \cite{Prada2004} present. Depending on the steepness of the density profile and on the instrument PSF some source extension might be observed. Nevertheless, the profiles which yield the largest flux \cite{Moore1998,Prada2004} predict nearly point-like sources.
 
@@ -284,10 +287,10 @@
 % All dark matter distributions that predict observable fluxes are cusped, yielding an approximately point-like source.
 
-Using fits of these dark matter profiles to the rotation data of the Milky Way predictions for the density profile $\rho_{\chi}$ of the dark matter can be made \cite{Fornego2004,Evans2004}. On the other hand, for a given model of the dark matter particles $m_{\chi},\;\langle \sigma v \rangle$ and $N_{\gamma}$ are determined. Combining the SUSY predictions with the predictions for the DM density profile
-predictions for the gamma flux from SUSY particle dark matter annihilation are derived.
+Using fits of these dark matter profiles to the rotation data of the Milky Way predictions for the density profile $\rho_{\chi}$ of the dark matter can be made \cite{Fornego2004,Evans2004}. On the other hand, for a given model of the dark matter particles $m_{\chi},\;\langle \sigma v \rangle$ and $N_{\gamma}$ are determined. Combining the particle physics predictions with the predictions for the DM density profile
+predictions for the gamma flux from dark matter particle annihilation are derived.
 %Assuming parameters for the SUSY models determine the neutralino mass, the thermally averaged annihilation cross section and the gamma yield. Combining both models about the dark matter distribution and SUSY 
 
 Figure \ref{fig:exclusion_lmits} shows exclusion limits for MAGIC (solid straight lines) for the four most promising sources,
-in the plane $N_{\gamma}(E_{\gamma}>E_{\mathrm{th}})\langle \sigma v \rangle$ vs. $m_{\chi}$. The energy threshold $E_{\mathrm{th}}$ has been assumed to be 100 GeV. Due to its proximity the GC yields the largest expected flux from particle dark matter annihilation and thus the lowest exclusion limit. Nevertheless, this minimum measurable flux is more than one order of magnitude above the highest fluxes predicted by SUSY models (full circles). Also the flux measured by the HESS experiment is far above the theoretical expectation (dotted line).
+in the plane $\langle \sigma v \rangle$ vs. $m_{\chi}$. The energy threshold $E_{\mathrm{th}}$ has been assumed to be 100 GeV. Due to its proximity the GC yields the largest expected flux from particle dark matter annihilation and thus the lowest exclusion limit. Nevertheless, this minimum measurable flux is more than one order of magnitude above the highest fluxes predicted by SUSY models (full circles). Also the flux measured by the HESS experiment is far above the theoretical expectation (dotted line).%N_{\gamma}(E_{\gamma}>E_{\mathrm{th}})
 
 