Index: trunk/MagicSoft/Mars/mjobs/MDataSet.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MDataSet.cc	(revision 6887)
+++ trunk/MagicSoft/Mars/mjobs/MDataSet.cc	(revision 6891)
@@ -170,6 +170,7 @@
 
 
-    fNameSource = env.GetValue("SourceName", "");
-    fCatalog    = env.GetValue("Catalog",    "~/Software/data/magic_favorites.edb");
+    fNameSource   = env.GetValue("SourceName", "");
+    fCatalog      = env.GetValue("Catalog",    "~/Software/data/magic_favorites.edb");
+    fIsWobbleMode = env.GetValue("WobbleMode", kFALSE);
 
     //Print();
@@ -214,4 +215,6 @@
     gLog << "SourceName: " << fNameSource << endl;
     gLog << "Catalog:    " << fCatalog << endl;
+
+    gLog << "WobbleMode: " << (fIsWobbleMode?"On":"Off") << endl;
 
     if (!TString(o).Contains("files", TString::kIgnoreCase))
Index: trunk/MagicSoft/Mars/mjobs/MDataSet.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MDataSet.h	(revision 6887)
+++ trunk/MagicSoft/Mars/mjobs/MDataSet.h	(revision 6891)
@@ -16,16 +16,16 @@
 {
 private:
-    UInt_t fNumAnalysis;      // Analysis number (artificial)
+    UInt_t  fNumAnalysis;     // Analysis number (artificial)
 
     TArrayI fNumSequencesOn;  // number of on-sequences
     TArrayI fNumSequencesOff; // number of off-sequences
 
-    TList fSequencesOn;       // list of names and paths of on-sequences
-    TList fSequencesOff;      // list of names and paths of off-sequences
+    TList   fSequencesOn;     // list of names and paths of on-sequences
+    TList   fSequencesOff;    // list of names and paths of off-sequences
 
+    TString fNameSource;      // Name of source from catalog
+    TString fCatalog;         // edb catalog (magic_favourites.edb)
 
-    TString  fNameSource;     // Name of source from catalog
-    TString  fCatalog;        // edb catalog (magic_favourites.edb)
-
+    Bool_t  fIsWobbleMode;    // Wobble Mode for this dataset?
 
     void Split(TString &runs, TArrayI &data) const;
@@ -51,4 +51,6 @@
     Bool_t GetSourcePos(MPointingPos &pos) const;
 
+    Bool_t IsWobbleMode() const { return fIsWobbleMode; }
+
     // Setter
     static Bool_t AddSequencesToList(const TList &list, MRead &read, char *id="I", Bool_t raw=kFALSE);
Index: trunk/MagicSoft/Mars/mjobs/MJCut.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCut.cc	(revision 6887)
+++ trunk/MagicSoft/Mars/mjobs/MJCut.cc	(revision 6891)
@@ -263,9 +263,10 @@
 {
     write.SetName(name);
-    write.AddContainer("MHillas",     "Events");
-    write.AddContainer("MHillasSrc",  "Events");
-    write.AddContainer("MHadronness", "Events", kFALSE);
-    write.AddContainer("MEnergyEst",  "Events", kFALSE);
-    write.AddContainer("DataType",    "Events");
+    write.AddContainer("MHillas",        "Events");
+    write.AddContainer("MHillasSrc",     "Events");
+    write.AddContainer("MHillasSrcAnti", "Events", kFALSE);
+    write.AddContainer("MHadronness",    "Events", kFALSE);
+    write.AddContainer("MEnergyEst",     "Events", kFALSE);
+    write.AddContainer("DataType",       "Events");
 
     // Should not be the default: Either as option, or as
@@ -321,7 +322,7 @@
 
     // Initialize default binnings
-    MBinning bins1(18, 0,  90,   "BinningAlpha",     "lin");
-    MBinning bins2(25, 10, 1e6 , "BinningEnergyEst", "log");
-    MBinning bins3(50, 0,  60,   "BinningTheta",     "cos");
+    MBinning bins1(18, 0,  90,  "BinningAlpha",     "lin");
+    MBinning bins2(30, 10, 1e6, "BinningEnergyEst", "log");
+    MBinning bins3(25, 0,  60,  "BinningTheta",     "cos"); // orig=50bins
     MBinning bins4("BinningFalseSource");
     plist.AddToList(&bins1);
@@ -383,8 +384,10 @@
     taskenv2.SetDefault(fCalcHadronness);
 
-    MFillH fill1a("MHHillasOffPre  [MHHillas]", "MHillas", "FillHillasPre");
-    MFillH fill2a("MHHillasOffPost [MHHillas]", "MHillas", "FillHillasPost");
+    MFillH fill1a("MHHillasOffPre  [MHHillas]", "MHillas",    "FillHillasPre");
+    MFillH fill2a("MHHillasOffPost [MHHillas]", "MHillas",    "FillHillasPost");
+    MFillH fill3a("MHVsSizeOffPost [MHVsSize]", "MHillasSrc", "FillVsSizePost");
     fill1a.SetNameTab("PreCut");
     fill2a.SetNameTab("PostCut");
+    fill3a.SetNameTab("VsSize");
 
     MPrint print2("MEffectiveOnTime");
@@ -418,5 +421,8 @@
     tlist2.AddToList(&cont2);
     if (!fWriteOnly)
+    {
         tlist2.AddToList(&fill2a);
+        tlist2.AddToList(&fill3a);
+    }
     if (!fWriteOnly)
         tlist2.AddToList(&falpha);
@@ -467,10 +473,13 @@
         scalc.SetWobbleMode(kFALSE); /********************/
 
-    MFillH fill1b("MHHillasOnPre  [MHHillas]", "MHillas", "FillHillasPre");
-    MFillH fill2b("MHHillasOnPost [MHHillas]", "MHillas", "FillHillasPost");
+    MFillH fill1b("MHHillasOnPre  [MHHillas]", "MHillas",    "FillHillasPre");
+    MFillH fill2b("MHHillasOnPost [MHHillas]", "MHillas",    "FillHillasPost");
+    MFillH fill3b("MHVsSizeOnPost [MHVsSize]", "MHillasSrc", "FillVsSizePost");
     fill1b.SetNameTab("PreCut");
     fill2b.SetNameTab("PostCut");
+    fill3b.SetNameTab("VsSize");
     fill1b.SetDrawOption(set.HasOffSequences()||fIsWobble?"same":"");
     fill2b.SetDrawOption(set.HasOffSequences()||fIsWobble?"same":"");
+    fill3b.SetDrawOption(set.HasOffSequences()||fIsWobble?"same":"");
 
     MFillH falpha2("MHAlpha", "MHillasSrc", "FillAlpha");
@@ -482,4 +491,5 @@
         tlist2.Replace(&fill1b);
         tlist2.Replace(&fill2b);
+        tlist2.Replace(&fill3b);
         tlist2.Replace(&falpha2);
         tlist2.Replace(&ffs2);